package trick;

import java.util.HashSet;

/**
 * 题目： 136. 只出现一次的数字 (singleNumber)
 * 描述：给你一个 非空 整数数组 nums ，除了某个元素只出现一次以外，其余每个元素均出现两次。找出那个只出现了一次的元素。
 * 你必须设计并实现线性时间复杂度的算法来解决此问题，且该算法只使用常量额外空间。
 *
 示例 1：
 输入：nums = [2,2,1]
 输出：1

 * 链接：https://leetcode.cn/problems/single-number/
 */
public class SingleNumber {
    public int singleNumber(int[] nums) {
        HashSet<Integer> set = new HashSet<>();
        for (int num : nums) {
            if (!set.add(num))  // add() 返回 false 表示已经存在
                set.remove(num);
        }
        // 直接从 set 里“弹”出唯一的元素
        return set.iterator().next();
    }

    /**
     * 直接对所有数做位异或
     异或满足 “a^a=0, 0^b=b” 的特性，所以成对出现的数都会被异或消掉，最后剩下的就是那个只出现一次的数。
     */
    public int singleNumber2(int[] nums) {
        int res = 0;
        for (int num : nums) {
            res ^= num;
        }
        return res;
    }

}
